import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import com.java4less.rmicropdf417.MicroPDF417;

//  RMicroPDF417
//  Copyright (C)
//
//  RReport@Confluencia.net
//  All rights reservedse
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - You may not copy and paste any code into external files.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material

public class MicroPDF417Demo extends JFrame {
  MicroPDF417 barcode = new MicroPDF417();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JButton btnSave = new JButton();
  JButton btnApply = new JButton();
  JButton btnPrint = new JButton();
  JButton btnExit = new JButton();
  JLabel jLabel1 = new JLabel();
  JTextField txtData = new JTextField();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JComboBox cCompaction = new JComboBox();
  JComboBox cFormat = new JComboBox();
  JTextField txtWidth = new JTextField();
  JTextField txtHeight = new JTextField();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel10 = new JLabel();
  JLabel jLabel11 = new JLabel();
  JLabel jLabel12 = new JLabel();
  JTextField txtSegment = new JTextField();
  JTextField txtSender = new JTextField();
  JTextField txtAddresse = new JTextField();
  JTextField txtTimestamp = new JTextField();
  JTextField txtFileId = new JTextField();
  JTextField txtFilename = new JTextField();
  JTextField txtFileSize = new JTextField();
  JLabel jLabel13 = new JLabel();
  JComboBox cResolution = new JComboBox();
  JTextField txtMargin = new JTextField();
  JLabel jLabel14 = new JLabel();

  public MicroPDF417Demo() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public static void main(String[] args) {
    MicroPDF417Demo microPDF417Demo = new MicroPDF417Demo();
    microPDF417Demo.setSize(410,515);
    microPDF417Demo.setLocation(100,100);
    microPDF417Demo.show();
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    barcode.setBounds(new Rectangle(2, 3, 395, 223));
    jTabbedPane1.setBounds(new Rectangle(3, 227, 394, 212));
    btnSave.setBounds(new Rectangle(200, 446, 79, 27));
    btnSave.setText("Save");
    btnApply.setText("Apply");
    btnApply.setBounds(new Rectangle(23, 446, 79, 27));
    btnPrint.setText("Print");
    btnPrint.setBounds(new Rectangle(111, 446, 79, 27));
    btnExit.setBounds(new Rectangle(291, 446, 79, 27));
    btnExit.setText("Exit");
    btnSave.setText("Save");
    btnSave.setBounds(new Rectangle(199, 444, 79, 27));
    btnSave.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnSave_actionPerformed(e);
      }
    });
    btnApply.setText("Apply");
    btnApply.setBounds(new Rectangle(22, 444, 79, 27));
    btnApply.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnApply_actionPerformed(e);
      }
    });
    btnPrint.setText("Print");
    btnPrint.setBounds(new Rectangle(110, 444, 79, 27));
    btnPrint.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPrint_actionPerformed(e);
      }
    });
    btnExit.setText("Exit");
    btnExit.setBounds(new Rectangle(290, 444, 79, 27));
    btnExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnExit_actionPerformed(e);
      }
    });
    jPanel2.setLayout(null);
    jLabel1.setToolTipText("");
    jLabel1.setText("Data");
    jLabel1.setBounds(new Rectangle(9, 12, 41, 17));
    txtData.setToolTipText("");
    txtData.setText("Micro PDF 417 test");
    txtData.setBounds(new Rectangle(63, 12, 308, 21));
    jLabel2.setText("Compaction");
    jLabel2.setBounds(new Rectangle(9, 40, 75, 17));
    jLabel3.setText("Format");
    jLabel3.setBounds(new Rectangle(9, 70, 64, 17));
    jLabel4.setToolTipText("");
    jLabel4.setText("Bar width");
    jLabel4.setBounds(new Rectangle(9, 100, 79, 17));
    jLabel5.setText("Bar height");
    jLabel5.setBounds(new Rectangle(9, 126, 72, 17));
    cCompaction.setBounds(new Rectangle(87, 39, 125, 21));
    cFormat.setBounds(new Rectangle(87, 66, 125, 21));
    txtWidth.setText("2");
    txtWidth.setBounds(new Rectangle(87, 96, 125, 21));
    txtHeight.setBounds(new Rectangle(86, 106, 124, 21));
    txtHeight.setText("7");
    txtHeight.setBounds(new Rectangle(87, 123, 125, 21));
    jPanel3.setLayout(null);
    jLabel6.setText("Segment");
    jLabel6.setBounds(new Rectangle(13, 19, 73, 17));
    jLabel7.setText("Sender");
    jLabel7.setBounds(new Rectangle(13, 51, 41, 17));
    jLabel8.setText("Addresse");
    jLabel8.setBounds(new Rectangle(13, 81, 84, 17));
    jLabel9.setText("Timestamp");
    jLabel9.setBounds(new Rectangle(13, 115, 75, 17));
    jLabel10.setText("Filename");
    jLabel10.setBounds(new Rectangle(207, 55, 87, 17));
    jLabel11.setText("File Id");
    jLabel11.setBounds(new Rectangle(207, 21, 70, 17));
    jLabel12.setText("File size");
    jLabel12.setBounds(new Rectangle(207, 84, 66, 17));
    txtSegment.setText("-1");
    txtSegment.setBounds(new Rectangle(88, 19, 63, 21));
    txtSender.setBounds(new Rectangle(88, 50, 111, 21));
    txtAddresse.setBounds(new Rectangle(88, 50, 63, 21));
    txtAddresse.setBounds(new Rectangle(89, 78, 111, 21));
    txtTimestamp.setBounds(new Rectangle(88, 50, 63, 21));
    txtTimestamp.setText("0");
    txtTimestamp.setBounds(new Rectangle(89, 108, 111, 21));
    txtFileId.setBounds(new Rectangle(88, 50, 63, 21));
    txtFileId.setToolTipText("");
    txtFileId.setText("0");
    txtFileId.setBounds(new Rectangle(269, 21, 111, 21));
    txtFilename.setBounds(new Rectangle(88, 50, 63, 21));
    txtFilename.setBounds(new Rectangle(270, 51, 111, 21));
    txtFileSize.setBounds(new Rectangle(88, 50, 63, 21));
    txtFileSize.setText("0");
    txtFileSize.setBounds(new Rectangle(270, 80, 111, 21));
    jLabel13.setBounds(new Rectangle(8, 152, 119, 17));
    jLabel13.setText("Printer Resolution");
    cResolution.setBounds(new Rectangle(128, 151, 85, 21));
    this.setTitle("Micro PDF 417 Demo");
    txtMargin.setBounds(new Rectangle(310, 41, 61, 21));
    txtMargin.setText("20");
    jLabel14.setBounds(new Rectangle(232, 45, 79, 17));
    jLabel14.setText("Margin");
    jLabel14.setToolTipText("");
    this.getContentPane().add(jTabbedPane1, null);
    jTabbedPane1.add(jPanel2, "MicroPDF");
    jPanel2.add(cFormat, null);
    jPanel2.add(jLabel1, null);
    jPanel2.add(txtData, null);
    jPanel2.add(cCompaction, null);
    jPanel2.add(jLabel2, null);
    jPanel2.add(jLabel3, null);
    jPanel2.add(txtWidth, null);
    jPanel2.add(jLabel4, null);
    jPanel2.add(jLabel5, null);
    jPanel2.add(txtHeight, null);
    jPanel2.add(jLabel13, null);
    jPanel2.add(cResolution, null);
    jPanel2.add(txtMargin, null);
    jPanel2.add(jLabel14, null);
    jTabbedPane1.add(jPanel3, "Structured Append");
    jPanel3.add(jLabel6, null);
    jPanel3.add(jLabel11, null);
    jPanel3.add(jLabel9, null);
    jPanel3.add(jLabel8, null);
    jPanel3.add(jLabel7, null);
    jPanel3.add(jLabel12, null);
    jPanel3.add(jLabel10, null);
    jPanel3.add(txtSegment, null);
    jPanel3.add(txtSender, null);
    jPanel3.add(txtAddresse, null);
    jPanel3.add(txtTimestamp, null);
    jPanel3.add(txtFileId, null);
    jPanel3.add(txtFilename, null);
    jPanel3.add(txtFileSize, null);
    this.getContentPane().add(barcode, null);
    this.getContentPane().add(btnExit, null);
    this.getContentPane().add(btnApply, null);
    this.getContentPane().add(btnPrint, null);
    this.getContentPane().add(btnSave, null);

    this.cCompaction.addItem("BINARY");
    this.cCompaction.addItem("TEXT");
    this.cCompaction.addItem("NUMERIC");

this.cFormat.addItem("1X11");
this.cFormat.addItem("1X14");
this.cFormat.addItem("1X17");
this.cFormat.addItem("1X20");
this.cFormat.addItem("1X24");
this.cFormat.addItem("1X28");
this.cFormat.addItem("2X8");
this.cFormat.addItem("2X11");
this.cFormat.addItem("2X14");
this.cFormat.addItem("2X17");
this.cFormat.addItem("2X20");
this.cFormat.addItem("2X23");
this.cFormat.addItem("2X26");
this.cFormat.addItem("3X6");
this.cFormat.addItem("3X8");
this.cFormat.addItem("3X10");
this.cFormat.addItem("3X12");
this.cFormat.addItem("3X15");
this.cFormat.addItem("3X20");
this.cFormat.addItem("3X26");
this.cFormat.addItem("3X32");
this.cFormat.addItem("3X38");
this.cFormat.addItem("3X44");
this.cFormat.addItem("4X4");
this.cFormat.addItem("4X6");
this.cFormat.addItem("4X8");
this.cFormat.addItem("4X10");
this.cFormat.addItem("4X12");
this.cFormat.addItem("4X15");
this.cFormat.addItem("4X20");
this.cFormat.addItem("4X26");
this.cFormat.addItem("4X32");
this.cFormat.addItem("4X38");
this.cFormat.addItem("4X44");

    this.cResolution.addItem("72 dpi (default)");
    this.cResolution.addItem("300 dpi");
    this.cResolution.addItem("600 dpi");

  }

  public void show() {
    super.show();
    btnApply_actionPerformed(null);
  }

  void btnApply_actionPerformed(ActionEvent e) {

  barcode.setCode(this.txtData.getText());
  barcode.setPDFPreferredFormat(barcode.FORMAT_1X11);
  if (cFormat.getSelectedIndex()>=0) barcode.setPDFPreferredFormat(this.cFormat.getSelectedIndex());
  barcode.setPDFMode("TEXT");
  if (this.cCompaction.getSelectedIndex()>=0) barcode.setPDFMode((String) this.cCompaction.getSelectedItem());

  barcode.setPDFStructuredAppendAddresse(this.txtAddresse.getText());
  barcode.setPDFStructuredAppendFileName(this.txtFilename.getText());
  barcode.setPDFStructuredAppendSender(this.txtSender.getText());
  barcode.setPDFStructuredAppendTimeStamp(this.txtTimestamp.getText());

  barcode.setPDFStructuredAppendSegment(-1);

  try {

    barcode.setModuleSize(Integer.parseInt(this.txtWidth.getText()));
    barcode.setbarHeight(Integer.parseInt(this.txtHeight.getText()));
    barcode.setPDFStructuredAppendSegment(Integer.parseInt(this.txtSegment.getText()));
    if (txtFileSize.getText().length()==0) txtFileSize.setText("0");
    barcode.setPDFStructuredAppendFileSize(Integer.parseInt(this.txtFileSize.getText()));
    barcode.setleftMargin(Integer.parseInt(this.txtMargin.getText()));
    barcode.settopMargin(Integer.parseInt(this.txtMargin.getText()));

    if (txtFileId.getText().length()==0) txtFileId.setText("0");
    barcode.setPDFStructuredAppendFileId(Integer.parseInt(this.txtFileId.getText()));


    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

 barcode.resetStructuredAppendPDF();
 if (barcode.getPDFStructuredAppendSegment()>-1) {

     int segment=barcode.getPDFStructuredAppendSegment();
     barcode.setPDFStructuredAppendSegment(1);
     //calculate number of segment needed
     barcode.prepareStructuredAppendPDF();
     barcode.setPDFStructuredAppendSegment(segment);

 }

    this.paintAll(this.getGraphics());
    this.repaint();
    barcode.paint(barcode.getGraphics());

}

  void btnPrint_actionPerformed(ActionEvent e) {


   // set printer resolution
    java.awt.PageAttributes pa= new PageAttributes();

    if (this.cResolution.getSelectedIndex()==1) pa.setPrinterResolution(300);
    if (this.cResolution.getSelectedIndex()==2) pa.setPrinterResolution(600);
    //pa.setPrinterResolution(barcode.getResolution());

    // get printer job
    java.awt.PrintJob pj=Toolkit.getDefaultToolkit().getPrintJob(this,"MicroPDF417",null,pa);

    java.awt.image.BufferedImage im=new java.awt.image.BufferedImage(barcode.getWidth(),barcode.getHeight(),java.awt.image.BufferedImage.TYPE_INT_RGB);
    Graphics g2=im.createGraphics();
    barcode.paintAll(g2);

    //    print barcode
    Graphics g= pj.getGraphics();

     g.drawImage(im,pj.getPageDimension().width/2,pj.getPageDimension().height/3,null);
    // end job
    pj.end();

  }

  void btnSave_actionPerformed(ActionEvent e) {

     FileDialog f=new FileDialog(this,"Select JPG File",FileDialog.SAVE);

     f.show();

     if (f.getFile()!=null) {
         barcode.setSize(barcode.getPreferredSize());
         String fi=f.getDirectory()+f.getFile();
         if (!fi.toUpperCase().endsWith("JPG")) fi=fi+".jpg";
         System.out.println(fi);
         com.java4less.encoder.ImageEncoder   be=  new com.java4less.encoder.ImageEncoder(barcode,"JPEG",fi);

         javax.swing.JOptionPane.showMessageDialog(this,"The JPEG file has been saved. We recommend you to use GIF or PNG formats for scanning purposes. See Documentation.");
       }

  }

  void btnExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }


}
