
//  RMicroPDF417
//  Copyright (C)
//
//  RReport@Confluencia.net
//  All rights reservedse
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - You may not copy and paste any code into external files.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material


import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
import com.java4less.rmicropdf417.MicroPDF417;

public class RMicroPDF417Servlet  extends HttpServlet
   {


  public static void main(String[] a) {

  }


         private boolean debug=false;

        /**
         * Handle the HTTP POST method by sending an e-mail
         *
         *
         */

	    public void init() throws ServletException  {

	    }

       // read paramters form request an create barcode
       // http://localhost:8080/examples/servlet/RMicroPDF417Servlet?DATA=AAADDEEE....
       public MicroPDF417 getBarcode(HttpServletRequest request) {

       	  MicroPDF417 cb=new MicroPDF417();

          if (request==null) return cb;

            if (request.getParameter("DEBUG")!=null)
               if (request.getParameter("DEBUG").toUpperCase().compareTo("ON")==0) debug =true;

          // READ DATA
          String dataStr=request.getParameter("DATA");
          if (dataStr!=null) cb.setCode(dataStr);

          String mode=request.getParameter("MODE");
          cb.setPDFMode("BINARY");
          if (mode!=null) {
             if (mode.compareTo("TEXT")==0) cb.setPDFMode("TEXT");
             if (mode.compareTo("NUMERIC")==0) cb.setPDFMode("NUMERIC");
             if (mode.compareTo("BINARY")==0) cb.setPDFMode("BINARY");
          }

          String ms=request.getParameter("MODULE_WIDTH");
          if (ms!=null)
             cb.setModuleSize(Integer.parseInt(ms));

          ms=request.getParameter("BARS_HEIGHT");
          if (ms!=null)
             cb.setbarHeight(Integer.parseInt(ms));

          String ma=request.getParameter("LEFT_MARGIN");
          if (ma!=null)
             cb.setleftMargin(Integer.parseInt(ma));

          ma=request.getParameter("TOP_MARGIN");
          if (ma!=null)
             cb.settopMargin(Integer.parseInt(ma));

          cb.setPDFPreferredFormat(cb.FORMAT_1X11);
          String preferredConf=request.getParameter("CONFIGURATION");
          if (preferredConf!=null) {
          if (preferredConf.compareTo("FORMAT_1X11")==0) cb.setPDFPreferredFormat(cb.FORMAT_1X11);
          if (preferredConf.compareTo("FORMAT_1X14")==0) cb.setPDFPreferredFormat(cb.FORMAT_1X14);
          if (preferredConf.compareTo("FORMAT_1X17")==0) cb.setPDFPreferredFormat(cb.FORMAT_1X17);
          if (preferredConf.compareTo("FORMAT_1X20")==0) cb.setPDFPreferredFormat(cb.FORMAT_1X20);
          if (preferredConf.compareTo("FORMAT_1X24")==0) cb.setPDFPreferredFormat(cb.FORMAT_1X24);
          if (preferredConf.compareTo("FORMAT_1X28")==0) cb.setPDFPreferredFormat(cb.FORMAT_1X28);
          if (preferredConf.compareTo("FORMAT_2X8")==0) cb.setPDFPreferredFormat(cb.FORMAT_2X8);
          if (preferredConf.compareTo("FORMAT_2X11")==0) cb.setPDFPreferredFormat(cb.FORMAT_2X11);
          if (preferredConf.compareTo("FORMAT_2X14")==0) cb.setPDFPreferredFormat(cb.FORMAT_2X14);
          if (preferredConf.compareTo("FORMAT_2X17")==0) cb.setPDFPreferredFormat(cb.FORMAT_2X17);
          if (preferredConf.compareTo("FORMAT_2X20")==0) cb.setPDFPreferredFormat(cb.FORMAT_2X20);
          if (preferredConf.compareTo("FORMAT_2X23")==0) cb.setPDFPreferredFormat(cb.FORMAT_2X23);
          if (preferredConf.compareTo("FORMAT_2X26")==0) cb.setPDFPreferredFormat(cb.FORMAT_2X26);
          if (preferredConf.compareTo("FORMAT_3X6")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X6);
          if (preferredConf.compareTo("FORMAT_3X8")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X8);
          if (preferredConf.compareTo("FORMAT_3X10")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X10);
          if (preferredConf.compareTo("FORMAT_3X12")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X12);
          if (preferredConf.compareTo("FORMAT_3X15")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X15);
          if (preferredConf.compareTo("FORMAT_3X20")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X20);
          if (preferredConf.compareTo("FORMAT_3X26")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X26);
          if (preferredConf.compareTo("FORMAT_3X32")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X32);
          if (preferredConf.compareTo("FORMAT_3X38")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X38);
          if (preferredConf.compareTo("FORMAT_3X44")==0) cb.setPDFPreferredFormat(cb.FORMAT_3X44);
          if (preferredConf.compareTo("FORMAT_4X4")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X4);
          if (preferredConf.compareTo("FORMAT_4X6")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X6);
          if (preferredConf.compareTo("FORMAT_4X8")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X8);
          if (preferredConf.compareTo("FORMAT_4X10")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X10);
          if (preferredConf.compareTo("FORMAT_4X12")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X12);
          if (preferredConf.compareTo("FORMAT_4X15")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X15);
          if (preferredConf.compareTo("FORMAT_4X20")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X20);
          if (preferredConf.compareTo("FORMAT_4X26")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X26);
          if (preferredConf.compareTo("FORMAT_4X32")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X32);
          if (preferredConf.compareTo("FORMAT_4X38")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X38);
          if (preferredConf.compareTo("FORMAT_4X44")==0) cb.setPDFPreferredFormat(cb.FORMAT_4X44);
          }

          return cb;

       }

       // Handle a request
       // 1. create barcode
       // 2. draw barcode in a Buffered Image
       // 3. encode image as GIF or JPEG and send it to the browser
        public void doGet (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException, IOException
        {

               PrintWriter		out;
               ServletOutputStream outb;

              String encode="jpeg";

               if (request!=null) {
                 if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();

                 if ((encode.toLowerCase().compareTo("gif")!=0) && ((encode.toLowerCase().compareTo("png")!=0))) encode="jpeg";
               }

               response.setContentType("image/"+encode);

		//out=response.getWriter();
		outb=response.getOutputStream();

                // avoid caching in browser
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		response.setDateHeader ("Expires",0);

               try { // Create buffer


               int w=400;
               int h=200;


               if (request!=null) {
                 if (request.getParameter("WIDTH")!=null) w=new Integer(request.getParameter("WIDTH")).intValue();
                 if (request.getParameter("HEIGHT")!=null) h=new Integer(request.getParameter("HEIGHT")).intValue();
               }

		java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
		java.awt.Graphics2D BarGraphics=BarImage.createGraphics();

                // get BarCode
                MicroPDF417 cb=getBarcode(request);

                 if (debug) System.out.println("Size: "+w+" "+h);
                cb.setSize(w,h);

                cb.paint(BarGraphics);

               if (encode.toLowerCase().compareTo("gif")==0) {
                 // download gif encoder from http://www.acme.com/resources/classes/Acme.tar.gz
                 // encode buffered image to a gif

                   Class enClass=Class.forName("Acme.JPM.Encoders.GifEncoder");
                   Class[] constructorParams = new Class[2];
                   constructorParams[0]=Class.forName("java.awt.Image");
                   constructorParams[1]=Class.forName("java.io.OutputStream");
                   Object[] constructorObj = new Object[2];
                   constructorObj[0]=BarImage;
                   constructorObj[1]=outb;

                   Object encoder= enClass.getConstructor(constructorParams).newInstance(constructorObj);

                    Class[] encodeParams = new Class[0];
                    Object[] encodeObj = new Object[0];

                    enClass.getMethod("encode",encodeParams).invoke(encoder,encodeObj);

                 // Acme.JPM.Encoders.GifEncoder encoder = new Acme.JPM.Encoders.GifEncoder(BarImage  ,outb);
                 // encoder.encode();
                }
                else
                if (encode.toLowerCase().compareTo("png")==0) {
                    // download from http://users.boone.net/wbrameld/pngencoder/

                  Class enClass=Class.forName("com.bigfoot.bugar.image.PNGEncoder");
                   Class[] constructorParams = new Class[2];
                   constructorParams[0]=Class.forName("java.awt.Image");
                   constructorParams[1]=Class.forName("java.io.OutputStream");
                   Object[] constructorObj = new Object[2];
                   constructorObj[0]=BarImage;
                   constructorObj[1]=outb;

                   Object encoder= enClass.getConstructor(constructorParams).newInstance(constructorObj);

                    Class[] encodeParams = new Class[0];
                    Object[] encodeObj = new Object[0];

                    enClass.getMethod("encodeImage",encodeParams).invoke(encoder,encodeObj);


                    //com.bigfoot.bugar.image.PNGEncoder en= new com.bigfoot.bugar.image.PNGEncoder(BarImage  ,outb);
                    //en.encodeImage();
                }
                else {
                  // create JPEG image
                  com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
                  encoder.encode( BarImage );
                }

              } catch (Exception e) { e.printStackTrace();}

	}


        public void doPost (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException
        {
        try {
            doGet(request,response);
            } catch (Exception e) { e.printStackTrace();}
	}

    }


